proc flow-finish {} {
    global sim_num num bw npcc ntcp apprate quiet tcp pcc psize duration
    set f [open output$sim_num/pcc-$bw-$npcc-$ntcp-$apprate.tr$num w]
    for {set i 0} {$i < $npcc} {incr i} {
	puts $f [expr [$pcc($i) set ndatapack_] * $psize * 8.0 / 1000.0 / $duration]
    }
    close $f
    set f [open output$sim_num/tcp-$bw-$npcc-$ntcp-$apprate.tr$num w]
    for {set i 0} {$i < $ntcp} {incr i} {
	puts $f [expr [$tcp($i) set ndatapack_] * $psize * 8.0 / 1000.0 / $duration]
    }
    close $f
}

set interval 1.0
set duration 1000.0
set psize 1000
ns-random 0

set sim_num [lindex $argv 0]
set num [lindex $argv 1]
set bw [lindex $argv 2]
set npcc [lindex $argv 3]
set ntcp [lindex $argv 4]
set apprate [lindex $argv 5]
set quiet 0
if { [lindex $argv 6] == "-quiet"} {set quiet 1}

set num_links [expr $npcc + $ntcp]

source ../../sim/normal/settings.tcl
source ../../sim/normal/common.tcl

Agent/PCCSink set InitHistorySize_ 120000
Agent/PCCSink set NumSamples_ 24
Agent/PCC set AppRate_ [expr $apprate * 1000.0 / 8.0]

#Agent/PCCSink set Toff_ 60
#Agent/PCCSink set Texp_ 10

set ns [new Simulator]

source ../../sim/normal/topologies.tcl
topo-dumbbell [expr $num_links]

[$ns simplex-link-op $n(0) $n(1) link] set delay_ 30ms
[$ns simplex-link-op $n(1) $n(0) link] set delay_ 30ms

set em [new ErrorModel]
$em unit pkt
$em set rate_ 0.025
$em ranvar [new RandomVariable/Uniform]
$em drop-target [new Agent/Null]
$ns link-lossmodel $em $n(0) $n(1)

for {set i 0} {$i < $npcc} {incr i} {
    if {$quiet == 0} {
	setupPCC [expr ($i*5+5) % 50] $duration "output$sim_num/pcc$i-$bw-$npcc-$ntcp-$apprate.tr$num" $s($i) $r($i)
    } else {
	setupPCC [expr ($i*5+5) % 50] $duration "" $s($i) $r($i)
    }
    $pcc_sink($i) set pcc_recv_nr_ $i
}
for {set i 0} {$i < $ntcp} {incr i} {
    if {$quiet == 0} {
	setupTCP 1.0 $duration "output$sim_num/tcp$i-$bw-$npcc-$ntcp-$apprate.tr$num" $s([expr $i+$npcc]) $r([expr $i+$npcc])
    } else {
	setupTCP 1.0 $duration "" $s([expr $i+$npcc]) $r([expr $i+$npcc])
    }
}

$ns at 200.0 "$em set rate_ 0.05"
$ns at 300.0 "$em set rate_ 0.025"
$ns at 400.0 "$em set rate_ 0.05"
$ns at 420.0 "$em set rate_ 0.025"
$ns at 600.0 "$em set rate_ 0.05"
$ns at 700.0 "$em set rate_ 0.025"
$ns at 800.0 "$em set rate_ 0.05"
$ns at 820.0 "$em set rate_ 0.025"

$ns at 0.0 "puts stderr 0"
$ns at 200.0 "puts stderr 200"
$ns at 400.0 "puts stderr 400"
$ns at 600.0 "puts stderr 600"
$ns at 800.0 "puts stderr 800"

$ns at $duration "flow-finish; close-all; exit 0"
$ns run
