proc flow-finish {} {
    global sim_num num bw npcc ntcp apprate quiet tcp pcc pcc_sink psize duration
    set f [open output$sim_num/pcc-$bw-$npcc-$ntcp-$apprate.tr$num w]
    for {set i 0} {$i < $npcc} {incr i} {
	puts $f "[expr [$pcc([expr 1+$i]) set ndatapack_] * $psize * 8.0 / 1000.0 / $duration] [expr [$pcc_sink([expr 1+$i]) set totalReceived_] * $psize * 8.0 / 1000.0 / $duration]"
    }
    close $f
    set f [open output$sim_num/tcp-$bw-$npcc-$ntcp-$apprate.tr$num w]
    for {set i 0} {$i < $ntcp} {incr i} {
	puts $f "[expr [$tcp($i) set ndatapack_] * $psize * 8.0 / 1000.0 / $duration]"
    }
    close $f
}

set interval 1.0
set duration 900.0
set psize 1000
ns-random 0

set sim_num [lindex $argv 0]
set num [lindex $argv 1]
set bw [lindex $argv 2]
set npcc [lindex $argv 3]
set ntcp [lindex $argv 4]
set apprate [lindex $argv 5]
set quiet 0
set queue [expr int($bw/8 * 0.1)]
if { [lindex $argv 6] == "-quiet"} {set quiet 1}

# additional rate monitor
set num_links [expr 1 + $npcc + $ntcp]
set bw [expr $bw + $apprate]

source ../../sim/normal/settings.tcl
source ../../sim/normal/common.tcl

Agent/PCCSink set InitHistorySize_ 120000
Agent/PCCSink set NumSamples_ 24
Agent/PCC set AppRate_ [expr $apprate * 1000.0 / 8.0]
#Agent/PCCSink set Toff_ 180
Agent/PCCSink set Texp_ 180

set ns [new Simulator]

source ../../sim/normal/topologies.tcl
topo-dumbbell [expr $num_links]
[$ns simplex-link-op $n(0) $n(1) link] set delay_ 180ms
[$ns simplex-link-op $n(1) $n(0) link] set delay_ 180ms

# monitor TCP-friendly rate
setupPCC 0 $duration "" $s(0) $r(0)
$pcc_sink(0) set always_on_ 1
$pcc_sink(0) set pcc_recv_nr_ 0

for {set i 0} {$i < $npcc} {incr i} {
    if {$quiet == 0} {
	setupPCC [expr ($i*5+5) % 50] $duration "output$sim_num/pcc$i-$bw-$npcc-$ntcp-$apprate.tr$num" $s([expr 1+$i]) $r([expr 1+$i])
    } else {
	setupPCC [expr ($i*5+5) % 50] $duration "" $s([expr 1+$i]) $r([expr 1+$i])
    }
    $pcc_sink([expr 1+$i]) set pcc_recv_nr_ [expr 1+$i]
}
for {set i 0} {$i < $ntcp} {incr i} {
    if {$quiet == 0} {
	setupTCP 1.0 $duration "output$sim_num/tcp$i-$bw-$npcc-$ntcp-$apprate.tr$num" $s([expr 1+$i+$npcc]) $r([expr 1+$i+$npcc])
    } else {
	setupTCP 1.0 $duration "" $s([expr 1+$i+$npcc]) $r([expr 1+$i+$npcc])
    }
}

$ns at $duration "flow-finish; close-all; exit 0"
$ns run
